// TestCountdownDllDlg.cpp
// 
// Revision Log
//
// Date       Who SAR     Notes
// ========== === ======= =====================================
// 2001-10-12 mph         Initial coding by Mark Henri of
//                        MPH Software - markhenri@home.net
// 
//
#include "TestCountdownDllDlg.h"
#include "..\CountdownDialog.h"


BOOL OnInitDialog( CTestCountdownDllDlg& dlg, WPARAM wParam, LPARAM lParam );
void OnCommand( CTestCountdownDllDlg& dlg, WPARAM wParam, LPARAM lParam );

int CTestCountdownDllDlg::DoModal()
{
   return DialogBoxParam( _instance, MAKEINTRESOURCE( IDD ), _hwnd,( DLGPROC )TestCountdownDllDlgProc,( LPARAM )this );
}

BOOL CALLBACK CTestCountdownDllDlg::TestCountdownDllDlgProc( HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam )
{
   static CTestCountdownDllDlg* dlg = NULL;

   switch ( message )
   {
   case WM_INITDIALOG:
      dlg = reinterpret_cast<CTestCountdownDllDlg*>( lParam ); // the class for this dialog
      dlg->InitializeControls( hwnd );
      return (BOOL) OnInitDialog( *dlg, wParam, lParam );

   case WM_COMMAND:
      OnCommand( *dlg, wParam, lParam );
      return FALSE;
   }

   return FALSE;
}

BOOL OnInitDialog( CTestCountdownDllDlg& dlg, WPARAM wParam, LPARAM lParam ) 
{
   //
   // Associate an icon with the dialog box.
   //
   SetClassLong( dlg.GetHwnd(), 
             GCL_HICON, 
             ( LONG )LoadIcon( dlg.GetInstance(),
             MAKEINTRESOURCE( IDI_COUNTDOWNDIALOGTEST ) ) );

   dlg._editCaption.SetText( "Sample Caption" );
   dlg._editPrompt.SetText( "Sample Prompt" );
   dlg._editSeconds.SetText( "2" );
   dlg._radiobuttonIdok.Select();

   return( TRUE );
}

////////////////////////////////////////////////////////////

void OnCommand( CTestCountdownDllDlg& dlg, WPARAM wParam, LPARAM lParam )
{
   int nId = LOWORD( wParam );
   HWND hwndCtl = (HWND)lParam;
   UINT codeNotify = HIWORD( wParam );

   switch ( nId ) 
   {
      case IDOK:
         {
            BOOL bUseLoadLibrary = dlg._checkboxUseLoadLibrary.IsChecked();
            BOOL bEndOnInactive = dlg._checkboxEndOnInactive.IsChecked();
            BOOL bUseIDOK = dlg._radiobuttonIdok.IsSelected();
            string s = dlg._editSeconds.GetText();
            int nSeconds = atoi( s.c_str() );
            string sCaption = dlg._editCaption.GetText();
            string sPrompt = dlg._editPrompt.GetText();

            if ( bUseLoadLibrary )
            {
               HMODULE hmodule = ::LoadLibrary("C:\\My Projects\\Examples\\_Win32\\CountdownDialog\\debug\\CountdownDialog.dll");
               if(hmodule != NULL)
               {
                  pfnCountdownDialog CDD = (pfnCountdownDialog)GetProcAddress(hmodule,"CountdownDialog");
                  if ( CDD != NULL )
                  {
                     int ret = CDD( dlg.GetHwnd(), sPrompt.c_str(), sCaption.c_str(), nSeconds,(bUseIDOK)?IDOK:IDCANCEL,bEndOnInactive);
                     if ( ret <= 0 )
                     {
                        MessageBox (NULL,"returned error","Error",0);
                     }
                  }
                  else
                  {
                     MessageBox (NULL,"GetProcAddress failed","Error",0);
                  }
                  FreeLibrary(hmodule);
               }
               else
               {
                  MessageBox (NULL,"CDD.DLL not loaded","Error",0);
               }
            }
            else
            {
               //HINSTANCE hinst = ::LoadLibrary( "CountdownDialog.dll" );
               int ret = CountdownDialog( dlg.GetHwnd(), 
                  sPrompt.c_str(), sCaption.c_str(), 
                  nSeconds, (bUseIDOK)?IDOK:IDCANCEL, bEndOnInactive );
               if ( ret == IDCANCEL )
                  ::EndDialog( dlg.GetHwnd(), ret );
            }
         }
         break;

      case IDCANCEL:
         EndDialog( dlg.GetHwnd(), nId );
         break;
   }
}

////////////////////////////////////////////////////////////

